
/*Start MAF default login page js functions*/
function loginButtonPressed() {
    var errorElement;
    errorElement = document.getElementById('oracle_access_error_id');
    errorElement.innerHTML = "";
}

function loginGetCSSClassNameIndex(currentClassName, className) {
    if (!currentClassName)
        return  - 1;
    else {
        if (className === currentClassName)
            return 0;
        else {
            var classNameLength = className.length;
            var currentClassNameLength = currentClassName.length;
            var nameIndex = currentClassName.indexOf(className);
            if (nameIndex >= 0) {
                var hasStart = (nameIndex == 0) || (currentClassName.charAt(nameIndex - 1) == " ");
                var endIndex = nameIndex + classNameLength;
                var hasEnd = (endIndex == currentClassNameLength) || (currentClassName.charAt(endIndex) == " ");
                if (hasStart && hasEnd)
                    return nameIndex;
                else {
                    var lastNameIndex = currentClassName.lastIndexOf(className);
                    if (lastNameIndex != nameIndex) {
                        hasStart = currentClassName.charAt(lastNameIndex - 1);
                        endIndex = lastNameIndex + classNameLength;
                        hasEnd = (endIndex == currentClassNameLength) || (currentClassName.charAt(endIndex) == " ");
                        if (hasStart && hasEnd)
                            return lastNameIndex;
                        else 
                            return currentClassName.indexOf(" " + className + " ");
                    }
                }
            }
            return  - 1;
        }
    }
}

function loginAddCSSClassName(domElement, className) {
    var added = false;
    if (className != null) {
        var currentClassName = domElement.className;
        var classNameIndex = loginGetCSSClassNameIndex(currentClassName, className);
        if (classNameIndex ==  - 1) {
            var newClassName = (currentClassName) ? className + " " + currentClassName : className;
            domElement.className = newClassName;
            added = true;
        }
    }
    return added;
}

function loginRemoveCSSClassName(domElement, className) {
    var removed = false;
    if (className != null) {
        var currentClassName = domElement.className;
        var classNameIndex = loginGetCSSClassNameIndex(currentClassName, className);
        if (classNameIndex !=  - 1) {
            var classNameEndIndex = classNameIndex + className.length;
            var beforeString = (classNameIndex == 0) ? null : currentClassName.substring(0, classNameIndex);
            var afterString = (classNameEndIndex == currentClassName.length) ? null : currentClassName.substring(classNameEndIndex + 1);// skip space
            var newClassName;
            if (beforeString == null) {
                if (afterString == null)
                    newClassName = "";
                else 
                    newClassName = afterString;
            }
            else {
                if (afterString == null)
                    newClassName = beforeString;
                else 
                    newClassName = beforeString + afterString;
            }
            domElement.className = newClassName;
            removed = true;
        }
    }
    return removed;
}

function pressed(element, isPressed) {
    if (isPressed)
        loginAddCSSClassName(element, "login-selected");
    else 
        loginRemoveCSSClassName(element, "login-selected");
}

function addAgentClass() {
    var agentType = "unknown";
    var userAgent = navigator.userAgent.toLowerCase();
    if (userAgent.indexOf("msie") !=  - 1 || userAgent.indexOf("trident") !=  - 1) {
        agentType = "trident";
    }
    else if (userAgent.indexOf("applewebkit") !=  - 1) {
        agentType = "webkit";
        if (userAgent.match(/ip(hone|ad|od)/)) {
            agentType = "iOS";
        }
        else if (userAgent.match(/android/)) {
            agentType = "Android";
        }
    }
    else if (userAgent.indexOf("gecko/") !=  - 1) {
        agentType = "gecko";
    }

    var agentClass = " login-" + agentType.toLowerCase();
    document.documentElement.className += agentClass;
}
addAgentClass();

function handleSubmit() {
    try {
        if (document.activeElement != null) {
            document.activeElement.blur();
        }
        var username = document.getElementById('oracle_access_user_id').value;
        var password = document.getElementById('oracle_access_pwd_id').value;
        if (username.trim().length == 0 || password.trim().length == 0) {
            var errorElement = document.getElementById('oracle_access_error_id');
            errorElement.innerHTML = getLocaleMessage('MSG_LOGIN_WARNING');;

            return true;
        }
        else {
            oracle_access_sendParams("oracle_access_submit_id");
        }
    }
    finally {
        return false;
    }
}
/*End MAF default login page js functions*/

/**
 * After loading of login html
 */
function onBodyLoad() {

    try {
        var lan = window.navigator.language;
        lan = getLangSuffix(lan);
        // console.log('lan=>'+lan);
        var filename = "../js/ebs-LoginBundle_" + lan + ".js";
        loadScript(filename, function () {
            //console.log('updateLoginFields..');
            updateLoginFields();
        });
    }
    finally {

    }

};

function updateLoginFields() {

    try {

        // TODO: App Development teams to update this statement with correct App Title Key 
        // from ebs-LoginBundle.js, for example APP_TITLE_APPROVALS, APP_TITLE_TIMECARDS and so on
        document.getElementById('message').innerHTML = getLocaleMessage('APP_TITLE_D_SUPERVISOR');

        // Update Login Page fields        
        document.getElementById('oracle_access_user_id').placeholder = getLocaleMessage('USERNAME');
        document.getElementById('oracle_access_user_id').setAttribute('aria-label', getLocaleMessage('USERNAME'));
        document.getElementById('oracle_access_pwd_id').placeholder = getLocaleMessage('PASSWORD');
        document.getElementById('oracle_access_pwd_id').setAttribute('aria-label', getLocaleMessage('PASSWORD'));
        document.getElementById('oracle_access_submit_id').value = getLocaleMessage('SIGNIN');
        setValue('REM_UN', 'REM_UN');
        setValue('REM_PWD', 'REM_PWD');
        setValue('KEEP_ME_LOGIN', 'KEEP_ME_LOGIN');
        setValue('DOMAIN_NAME', 'DOMAIN_NAME');

    }

    catch (e) {
        alert("Error: " + e.description);
    }
}

function setValue(elementId, key) {
    try {
        document.getElementById(elementId).innerHTML = getLocaleMessage(key);

    }
    catch (e) {
        //do nothing
    }
}

function loadScript(jsFile, callback) {

    var fileref = document.createElement("script")
    fileref.type = "text/javascript";

    fileref.onload = function () {
        callback();
    };
    fileref.onerror = function () {
        loadDefault();
    };

    fileref.src = jsFile;
    if (typeof fileref != "undefined") {
        document.getElementsByTagName("head")[0].appendChild(fileref)
    }
};

function loadDefault() {
    loadScript('../js/ebs-LoginBundle.js', function () {
        updateLoginFields();
    });
}

function getLocaleMessage(message) {
    var n = window['messages'];
    return n[message];
};

function getLangSuffix(lang) {
    var territory;
    var language;
    var idx = lang.indexOf('-');
    if ( - 1 != idx) {
        language = lang.substring(0, idx);
        territory = lang.substring(idx + 1, lang.length);
        language = language.toLowerCase();
        territory = territory.toUpperCase();
    }
    else {
        language = lang.toLowerCase();
    }
    var langSuffix = language;
    if ("zh" == language && "TW" == territory) {
        langSuffix = "zh_TW";
    }
    else if ("es" == language && "US" == territory) {
        langSuffix = "es_US";
    }
    else if ("es" == language && "MX" == territory) {
        langSuffix = "es_US";
    }
    else if ("fr" == language && "CA" == territory) {
        langSuffix = "fr_CA";
    }
    else if ("pt" == language && "BR" == territory) {
        langSuffix = "pt_BR";
    }
    else if ("zh" == language && "HK" == territory) {
        langSuffix = "zh_TW";
    }
    else if ("es" == language && "XL" == territory) {
        langSuffix = "es_US";
    }
    return langSuffix;
};
document.addEventListener("showpagecomplete", afterPageComplete, false);

function afterPageComplete() {
    try {
        keyup(document.getElementById('oracle_access_user_id'), document.getElementById('unClear'));
    }
    catch (e) {

    }
}

function keyup(inTxt, btnClr) {
    //var searchForm = document.getElementById('_txt');
    //alert(searchForm.value);
    //var clear = document.getElementById('_clear');
    if (inTxt.value.length) {
        btnClr.style.visibility = "visible";
    }
    else {
        btnClr.style.visibility = "hidden";
    }
}

function fbclear(btnClr, inTxt) {
    btnClr.style.visibility = "hidden";
    inTxt.value = "";
}